unit ULiss3d;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin;

type
  TForm1 = class(TForm)
    Button1: TButton;
    xfspin: TSpinEdit;
    zfspin: TSpinEdit;
    yfspin: TSpinEdit;
    BZufall: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure xfspinChange(Sender: TObject);
    procedure yfspinChange(Sender: TObject);
    procedure zfspinChange(Sender: TObject);
    procedure randomFigure;
    procedure repaintLiss;
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure BZufallClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    drag: Boolean;
    { Private-Deklarationen }
  public
    ppf,xf,yf,zf,moldx,moldy: integer;
    xang,yang,df: real;
    { Public-Deklarationen }
  end;

type
  ddcoord = record
    x,y: real
  end;

type
  dddcoord = record
    x,y,z: real
  end;

var
  Form1: TForm1;

const k=800; // some kind of zoom factor
      pi180=pi/180;
implementation

{$R *.DFM}

FUNCTION  GGT(A,B: LONGINT): LONGINT;
BEGIN
IF B>A  THEN GGT:=GGT(B,A);
IF B<>0 THEN GGT:=GGT(B,A MOD B)
ELSE GGT:=A;
END;

FUNCTION  KGV(A,B: LONGINT): LONGINT;
BEGIN
KGV:=ROUND(A*B/GGT(A,B));
END;

function xycoord(a: dddcoord): ddcoord;
begin
   xycoord.x:= a.x + (300 - a.x) * (0.5-(k/(a.z+k)));
   xycoord.y:= a.y + (225 - a.y) * (0.5-(k/(a.z+k)));
end;

function xzturn(a: dddcoord; W: real): dddcoord;
var D,G,R: real;
begin
   D:=arctan(a.x/a.z);             //     { Ausgangswinkel }
   G:=D+(pi/180)*W;             //      { Drehwinkel }
   if a.z<0 then G:=G+(pi);
   R:=sqrt(a.z*a.z+a.x*a.x); //         { Radius }
   xzturn.z:=R*cos(G);
   xzturn.x:=R*sin(G);
   xzturn.y:=a.y;
end;

function yzturn(a: dddcoord; W: real): dddcoord;
var D,G,R: real;
begin
   D:=arctan(a.y/a.z);             //     { Ausgangswinkel }
   G:=D+(pi/180)*W;             //      { Drehwinkel }
   if a.z<0 then G:=G+(pi);
   R:=sqrt(a.z*a.z+a.y*a.y); //         { Radius }
   yzturn.z:=R*cos(G);
   yzturn.y:=R*sin(G);
   yzturn.x:=a.x;
end;

procedure setDensity;
  var tr: real;
  begin

  tr := ggt(Form1.xf,Form1.yf);
  tr := ggt(round(tr),Form1.zf);
  tr := (360.0*pi180)/tr;

  Form1.df := tr/Form1.ppf*1.001;
end;

procedure TForm1.randomFigure;
begin
  xf:=random(99)+1;
  yf:=random(99)+1;
  zf:=random(99)+1;
  Form1.xfspin.Value:=xf;
  Form1.yfspin.Value:=yf;
  Form1.zfspin.Value:=zf;
  setDensity;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     randomize;
     xang:=0;
     yang:=0;
     ppf:=5000;
     randomFigure;
     repaintLiss;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
     RepaintLiss;
end;

procedure TForm1.RepaintLiss();
var ampx,ampy,ampaddx,ampaddy: real;
    screenx, screeny, fluchtx, fluchty, i: integer;
    a: dddcoord;
    e: ddcoord;
begin
     Canvas.FillRect(ClientRect);
     ampx    := 0.25;
     ampy    := 0.25;
     ampaddx := (1.0-2.0*ampx) / 2.0;
     ampaddy := (1.0-2.0*ampy) / 2.0;
     screenx := 600;
     screeny := 450;
     fluchtx := 300;
     fluchty := 225;

     Canvas.Pen.Color := clBlue;

     for i:=1 to 5000 do
     begin
          a.x := (sin(xf*df*i{+xp}) + 1.0) * screenx * ampx + ampaddx * screenx;
          a.y := (sin(yf*df*i{+yp}) + 1.0) * screeny * ampy + ampaddy * screeny;
          a.z :=  sin(zf*df*i{+zp}) * 100 + 70;
          a.x := a.x-400*0.75;
          a.z := a.z-50;
          a   := xzturn(a, xang);
          a.x := a.x+400*0.75;
          a.z := a.z+240;
          a.y := a.y-300*0.75;
          a.z := a.z-250;
          a   := yzturn(a, yang);
          a.y := a.y+300*0.75;
          a.z := a.z+440;

	  e := xycoord(a);
          if i>1 then
             Canvas.LineTo(round(e.x),round(e.y))
          else
             Canvas.MoveTo(round(e.x),round(e.y));
     end;
     //Canvas.CopyRect(ClientRect,PixBuffer,ClientRect);
end;

procedure TForm1.xfspinChange(Sender: TObject);
begin
xf:=xfspin.Value;
end;

procedure TForm1.yfspinChange(Sender: TObject);
begin
if(yfspin.Value>100) then yfspin.Value:=100;
if(yfspin.Value<1) then yfspin.Value:=1;

yf:=yfspin.Value;
end;

procedure TForm1.zfspinChange(Sender: TObject);
begin
zf:=zfspin.Value;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     drag := TRUE;
     moldx:=X;
     moldy:=Y;
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     drag := FALSE;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
     if(drag) then begin
              xang := xang+(X-moldx);
              yang := yang+(Y-moldy);
              moldx:=X;
              moldy:=Y;
              RepaintLiss;
     end;
end;

procedure TForm1.BZufallClick(Sender: TObject);
begin
randomFigure;
RepaintLiss;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
RepaintLiss;
end;

end.
